import { ActualProvider, DependencyProvider, Factory, NameSelector } from './types';
import { ILifetime } from './Lifetime';
declare type LifetimeProvider<T, E> = new (name: string, factoryFunction: Factory<T, E>) => ILifetime<T, E>;
declare type ProviderProvider<E> = {
    prototype: E;
    name: string;
    new (): E;
};
declare type DependencyOptions<T, E> = {
    dependency?: undefined;
    factory: Factory<T, E>;
    selector: NameSelector<T, E>;
} | {
    dependency: DependencyProvider<T, E>;
    factory?: Factory<T, E>;
    selector?: NameSelector<T, E>;
} | DependencyProvider<T, E>;
export declare class Container<E> {
    private static provider?;
    readonly template: Required<E>;
    private readonly lifetimes;
    private readonly dependencyToProvider;
    static getOrCreate<E>(factory?: () => Container<E>): ActualProvider<Required<E>>;
    static getOrCreateAsync<E>(factory?: () => Promise<Container<E>>): Promise<ActualProvider<Required<E>>>;
    constructor(ProviderTemplate: ProviderProvider<E>);
    add<T>(Lifetime: LifetimeProvider<T, Required<E>>, options: DependencyOptions<T, Required<E>>): void;
    tryAdd<T>(Lifetime: LifetimeProvider<T, Required<E>>, options: DependencyOptions<T, Required<E>>): boolean;
    get<T>(item: NameSelector<T, E>): ILifetime<T, E> | undefined;
    remove<T>(item: NameSelector<T, Required<E>>): boolean;
    build(validate?: boolean): ActualProvider<Required<E>>;
    resolveProperty<T>(item?: NameSelector<T, Required<E>>, dependency?: DependencyProvider<T, Required<E>>): string;
    private resolvePropertyConstructor;
    private preBuildValidate;
}
export {};
