"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Container = void 0;
var InternalProvider_1 = require("./InternalProvider");
var utils_1 = require("./utils");
var Errors_1 = require("./Errors");
var Container = /** @class */ (function () {
    function Container(ProviderTemplate) {
        Object.defineProperty(this, "template", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "lifetimes", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: {}
        });
        Object.defineProperty(this, "dependencyToProvider", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.template = new ProviderTemplate();
        this.dependencyToProvider = Object.keys(this.template).reduce(function (a, b) {
            a[b.toLowerCase()] = b;
            return a;
        }, {});
    }
    Object.defineProperty(Container, "getOrCreate", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (factory) {
            if (this.provider)
                return this.provider;
            if (!factory)
                throw new Error('Factory not provided and no global provider exists');
            return (this.provider = factory().build());
        }
    });
    Object.defineProperty(Container, "getOrCreateAsync", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (factory) {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (this.provider)
                                return [2 /*return*/, this.provider];
                            if (!factory)
                                throw new Error('Factory not provided and no global provider exists');
                            _a = this;
                            return [4 /*yield*/, factory()];
                        case 1: return [2 /*return*/, (_a.provider = (_b.sent()).build())];
                    }
                });
            });
        }
    });
    Object.defineProperty(Container.prototype, "add", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (Lifetime, options) {
            if (!this.tryAdd(Lifetime, options)) {
                var name_1 = this.resolvePropertyConstructor(options)[0];
                throw new Errors_1.DuplicateDependencyError(name_1);
            }
        }
    });
    Object.defineProperty(Container.prototype, "tryAdd", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (Lifetime, options) {
            var _a = this.resolvePropertyConstructor(options), name = _a[0], factory = _a[1], dependency = _a[2];
            if (!name)
                throw new Errors_1.UnknownDependencyError((dependency === null || dependency === void 0 ? void 0 : dependency.name) || '');
            if (this.lifetimes[name])
                return false;
            this.lifetimes[name] = new Lifetime(name, factory);
            return true;
        }
    });
    Object.defineProperty(Container.prototype, "get", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (item) {
            return this.lifetimes[this.resolveProperty(item)];
        }
    });
    Object.defineProperty(Container.prototype, "remove", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (item) {
            var name = this.resolveProperty(item);
            if (!this.lifetimes[name])
                return false;
            delete this.lifetimes[name];
            return true;
        }
    });
    Object.defineProperty(Container.prototype, "build", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (validate) {
            var _this = this;
            if (validate === void 0) { validate = false; }
            this.preBuildValidate();
            var createContext = function (validation, context) {
                var provider = new InternalProvider_1.InternalProvider(_this, createContext, validation, context);
                Object.keys(_this.template).forEach(function (name) {
                    Object.defineProperty(provider, name, { get: function () { return provider.get(name); } });
                });
                return provider;
            };
            return createContext({ validate: validate, trail: {} }, null);
        }
    });
    Object.defineProperty(Container.prototype, "resolveProperty", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (item, dependency) {
            if (item)
                return typeof item === 'string' ? item : item((0, utils_1.properties)(this.template));
            if (dependency)
                return this.dependencyToProvider[dependency.name.toLowerCase()];
            return '';
        }
    });
    Object.defineProperty(Container.prototype, "resolvePropertyConstructor", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (options) {
            if (typeof options === 'function') {
                return [this.resolveProperty(undefined, options), function (p) { return new options(p); }, options];
            }
            else if (options.dependency) {
                var dependency_1 = options.dependency, selector = options.selector, _a = options.factory, factory = _a === void 0 ? function (p) { return new dependency_1(p); } : _a;
                return [this.resolveProperty(selector, dependency_1), factory, dependency_1];
            }
            else {
                var selector = options.selector, factory = options.factory;
                return [this.resolveProperty(selector), factory, undefined];
            }
        }
    });
    Object.defineProperty(Container.prototype, "preBuildValidate", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            var _this = this;
            var missing = Object.keys(this.template)
                .filter(function (key) { return !_this.lifetimes[key]; })
                .map(function (key) { return new Errors_1.ExistenceDependencyError(key); });
            if (missing.length === 1)
                throw missing[0];
            else if (missing.length > 1)
                throw new Errors_1.MultiDependencyError(missing);
        }
    });
    return Container;
}());
exports.Container = Container;
