import { Container } from './Container';
import { NameSelector, ProviderContext, ProviderCreator, ProviderValidation } from './types';
export declare class InternalProvider<E> {
    readonly _: {
        container: Container<E>;
        create: ProviderCreator<Required<E>>;
        validation: ProviderValidation<Required<E>>;
        context: ProviderContext<Required<E>>;
    };
    constructor(container: Container<E>, create: ProviderCreator<Required<E>>, validation: ProviderValidation<E>, context: ProviderContext<E>);
    get<T>(nameSelector: NameSelector<T, Required<E>>): T;
    validate(): void;
}
