"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Singleton = void 0;
var Errors_1 = require("../Errors");
var Singleton = /** @class */ (function () {
    function Singleton(name, factory) {
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "factory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "value", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.name = name;
        this.factory = factory;
    }
    Object.defineProperty(Singleton.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (provider) {
            var _a;
            if (this.value)
                return this.value;
            var _b = provider._, _c = _b.validation, validate = _c.validate, trail = _c.trail, create = _b.create, context = _b.context;
            if (validate) {
                if (trail[this.name])
                    throw new Errors_1.CircularDependencyError(this.name, this.name);
                provider = create({ validate: validate, lastSingleton: this.name, trail: __assign(__assign({}, trail), (_a = {}, _a[this.name] = true, _a)) }, context);
            }
            return (this.value = this.factory(provider));
        }
    });
    return Singleton;
}());
exports.Singleton = Singleton;
