import { Keys } from './utils';
import { InternalProvider } from './InternalProvider';
export declare type Factory<T, E> = (provider: E) => T;
export declare type ProviderValidation<E> = {
    lastSingleton?: string;
    trail: Record<string, boolean>;
    validate: boolean;
};
export declare type ProviderContext<E> = Record<string, any>;
export declare type ProviderCreator<E> = (validation: ProviderValidation<E>, context: ProviderContext<E>) => ActualProvider<E>;
export declare type ActualProvider<E> = E & InternalProvider<E>;
export declare type DependencyProvider<T, E> = {
    prototype: T;
    name: string;
    new (provider: E): T;
} | {
    prototype: T;
    name: string;
    new (): T;
};
export declare type NameSelector<T, E> = string | ((p: Keys<T, E>) => string);
